﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SiLACertificateGenerator.ViewModels
{
    public static class Countries
    {
        public static CountryViewModel? Get(string countryCode)
        {
            return AllCountries.FirstOrDefault(c => string.Equals(c.Code, countryCode, StringComparison.OrdinalIgnoreCase));
        }

        public static IList<CountryViewModel> AllCountries { get; } = new List<CountryViewModel>
        {
            new CountryViewModel("(omit country)", null),
            new CountryViewModel("Afghanistan", "AF"),
            new CountryViewModel("Åland Islands", "AX"),
            new CountryViewModel("Albania", "AL"),
            new CountryViewModel("Algeria", "DZ"),
            new CountryViewModel("American Samoa", "AS"),
            new CountryViewModel("Andorra", "AD"),
            new CountryViewModel("Angola", "AO"),
            new CountryViewModel("Anguilla", "AI"),
            new CountryViewModel("Antarctica", "AQ"),
            new CountryViewModel("Antigua and Barbuda", "AG"),
            new CountryViewModel("Argentina", "AR"),
            new CountryViewModel("Armenia", "AM"),
            new CountryViewModel("Aruba", "AW"),
            new CountryViewModel("Australia", "AU"),
            new CountryViewModel("Austria", "AT"),
            new CountryViewModel("Azerbaijan", "AZ"),
            new CountryViewModel("Bahamas", "BS"),
            new CountryViewModel("Bahrain", "BH"),
            new CountryViewModel("Bangladesh", "BD"),
            new CountryViewModel("Barbados", "BB"),
            new CountryViewModel("Belarus", "BY"),
            new CountryViewModel("Belgium", "BE"),
            new CountryViewModel("Belize", "BZ"),
            new CountryViewModel("Benin", "BJ"),
            new CountryViewModel("Bermuda", "BM"),
            new CountryViewModel("Bhutan", "BT"),
            new CountryViewModel("Bolivia (Plurinational State of)", "BO"),
            new CountryViewModel("Bonaire, Sint Eustatius and Saba", "BQ"),
            new CountryViewModel("Bosnia and Herzegovina", "BA"),
            new CountryViewModel("Botswana", "BW"),
            new CountryViewModel("Bouvet Island", "BV"),
            new CountryViewModel("Brazil", "BR"),
            new CountryViewModel("British Indian Ocean Territory", "IO"),
            new CountryViewModel("Brunei Darussalam", "BN"),
            new CountryViewModel("Bulgaria", "BG"),
            new CountryViewModel("Burkina Faso", "BF"),
            new CountryViewModel("Burundi", "BI"),
            new CountryViewModel("Cabo Verde", "CV"),
            new CountryViewModel("Cambodia", "KH"),
            new CountryViewModel("Cameroon", "CM"),
            new CountryViewModel("Canada", "CA"),
            new CountryViewModel("Cayman Islands", "KY"),
            new CountryViewModel("Central African Republic", "CF"),
            new CountryViewModel("Chad", "TD"),
            new CountryViewModel("Chile", "CL"),
            new CountryViewModel("China", "CN"),
            new CountryViewModel("Christmas Island", "CX"),
            new CountryViewModel("Cocos (Keeling) Islands", "CC"),
            new CountryViewModel("Colombia", "CO"),
            new CountryViewModel("Comoros", "KM"),
            new CountryViewModel("Congo", "CG"),
            new CountryViewModel("Congo (Democratic Republic of the)", "CD"),
            new CountryViewModel("Cook Islands", "CK"),
            new CountryViewModel("Costa Rica", "CR"),
            new CountryViewModel("Côte d'Ivoire", "CI"),
            new CountryViewModel("Croatia", "HR"),
            new CountryViewModel("Cuba", "CU"),
            new CountryViewModel("Curaçao", "CW"),
            new CountryViewModel("Cyprus", "CY"),
            new CountryViewModel("Czechia", "CZ"),
            new CountryViewModel("Denmark", "DK"),
            new CountryViewModel("Djibouti", "DJ"),
            new CountryViewModel("Dominica", "DM"),
            new CountryViewModel("Dominican Republic", "DO"),
            new CountryViewModel("Ecuador", "EC"),
            new CountryViewModel("Egypt", "EG"),
            new CountryViewModel("El Salvador", "SV"),
            new CountryViewModel("Equatorial Guinea", "GQ"),
            new CountryViewModel("Eritrea", "ER"),
            new CountryViewModel("Estonia", "EE"),
            new CountryViewModel("Ethiopia", "ET"),
            new CountryViewModel("Falkland Islands (Malvinas)", "FK"),
            new CountryViewModel("Faroe Islands", "FO"),
            new CountryViewModel("Fiji", "FJ"),
            new CountryViewModel("Finland", "FI"),
            new CountryViewModel("France", "FR"),
            new CountryViewModel("French Guiana", "GF"),
            new CountryViewModel("French Polynesia", "PF"),
            new CountryViewModel("French Southern Territories", "TF"),
            new CountryViewModel("Gabon", "GA"),
            new CountryViewModel("Gambia", "GM"),
            new CountryViewModel("Georgia", "GE"),
            new CountryViewModel("Germany", "DE"),
            new CountryViewModel("Ghana", "GH"),
            new CountryViewModel("Gibraltar", "GI"),
            new CountryViewModel("Greece", "GR"),
            new CountryViewModel("Greenland", "GL"),
            new CountryViewModel("Grenada", "GD"),
            new CountryViewModel("Guadeloupe", "GP"),
            new CountryViewModel("Guam", "GU"),
            new CountryViewModel("Guatemala", "GT"),
            new CountryViewModel("Guernsey", "GG"),
            new CountryViewModel("Guinea", "GN"),
            new CountryViewModel("Guinea-Bissau", "GW"),
            new CountryViewModel("Guyana", "GY"),
            new CountryViewModel("Haiti", "HT"),
            new CountryViewModel("Heard Island and McDonald Islands", "HM"),
            new CountryViewModel("Holy See", "VA"),
            new CountryViewModel("Honduras", "HN"),
            new CountryViewModel("Hong Kong", "HK"),
            new CountryViewModel("Hungary", "HU"),
            new CountryViewModel("Iceland", "IS"),
            new CountryViewModel("India", "IN"),
            new CountryViewModel("Indonesia", "ID"),
            new CountryViewModel("Iran (Islamic Republic of)", "IR"),
            new CountryViewModel("Iraq", "IQ"),
            new CountryViewModel("Ireland", "IE"),
            new CountryViewModel("Isle of Man", "IM"),
            new CountryViewModel("Israel", "IL"),
            new CountryViewModel("Italy", "IT"),
            new CountryViewModel("Jamaica", "JM"),
            new CountryViewModel("Japan", "JP"),
            new CountryViewModel("Jersey", "JE"),
            new CountryViewModel("Jordan", "JO"),
            new CountryViewModel("Kazakhstan", "KZ"),
            new CountryViewModel("Kenya", "KE"),
            new CountryViewModel("Kiribati", "KI"),
            new CountryViewModel("Korea (Democratic People's Republic of)", "KP"),
            new CountryViewModel("Korea (Republic of)", "KR"),
            new CountryViewModel("Kuwait", "KW"),
            new CountryViewModel("Kyrgyzstan", "KG"),
            new CountryViewModel("Lao People's Democratic Republic", "LA"),
            new CountryViewModel("Latvia", "LV"),
            new CountryViewModel("Lebanon", "LB"),
            new CountryViewModel("Lesotho", "LS"),
            new CountryViewModel("Liberia", "LR"),
            new CountryViewModel("Libya", "LY"),
            new CountryViewModel("Liechtenstein", "LI"),
            new CountryViewModel("Lithuania", "LT"),
            new CountryViewModel("Luxembourg", "LU"),
            new CountryViewModel("Macao", "MO"),
            new CountryViewModel("Macedonia (the former Yugoslav Republic of)", "MK"),
            new CountryViewModel("Madagascar", "MG"),
            new CountryViewModel("Malawi", "MW"),
            new CountryViewModel("Malaysia", "MY"),
            new CountryViewModel("Maldives", "MV"),
            new CountryViewModel("Mali", "ML"),
            new CountryViewModel("Malta", "MT"),
            new CountryViewModel("Marshall Islands", "MH"),
            new CountryViewModel("Martinique", "MQ"),
            new CountryViewModel("Mauritania", "MR"),
            new CountryViewModel("Mauritius", "MU"),
            new CountryViewModel("Mayotte", "YT"),
            new CountryViewModel("Mexico", "MX"),
            new CountryViewModel("Micronesia (Federated States of)", "FM"),
            new CountryViewModel("Moldova (Republic of)", "MD"),
            new CountryViewModel("Monaco", "MC"),
            new CountryViewModel("Mongolia", "MN"),
            new CountryViewModel("Montenegro", "ME"),
            new CountryViewModel("Montserrat", "MS"),
            new CountryViewModel("Morocco", "MA"),
            new CountryViewModel("Mozambique", "MZ"),
            new CountryViewModel("Myanmar", "MM"),
            new CountryViewModel("Namibia", "NA"),
            new CountryViewModel("Nauru", "NR"),
            new CountryViewModel("Nepal", "NP"),
            new CountryViewModel("Netherlands", "NL"),
            new CountryViewModel("New Caledonia", "NC"),
            new CountryViewModel("New Zealand", "NZ"),
            new CountryViewModel("Nicaragua", "NI"),
            new CountryViewModel("Niger", "NE"),
            new CountryViewModel("Nigeria", "NG"),
            new CountryViewModel("Niue", "NU"),
            new CountryViewModel("Norfolk Island", "NF"),
            new CountryViewModel("Northern Mariana Islands", "MP"),
            new CountryViewModel("Norway", "NO"),
            new CountryViewModel("Oman", "OM"),
            new CountryViewModel("Pakistan", "PK"),
            new CountryViewModel("Palau", "PW"),
            new CountryViewModel("Palestine, State of", "PS"),
            new CountryViewModel("Panama", "PA"),
            new CountryViewModel("Papua New Guinea", "PG"),
            new CountryViewModel("Paraguay", "PY"),
            new CountryViewModel("Peru", "PE"),
            new CountryViewModel("Philippines", "PH"),
            new CountryViewModel("Pitcairn", "PN"),
            new CountryViewModel("Poland", "PL"),
            new CountryViewModel("Portugal", "PT"),
            new CountryViewModel("Puerto Rico", "PR"),
            new CountryViewModel("Qatar", "QA"),
            new CountryViewModel("Réunion", "RE"),
            new CountryViewModel("Romania", "RO"),
            new CountryViewModel("Russian Federation", "RU"),
            new CountryViewModel("Rwanda", "RW"),
            new CountryViewModel("Saint Barthélemy", "BL"),
            new CountryViewModel("Saint Helena, Ascension and Tristan da Cunha", "SH"),
            new CountryViewModel("Saint Kitts and Nevis", "KN"),
            new CountryViewModel("Saint Lucia", "LC"),
            new CountryViewModel("Saint Martin (French part)", "MF"),
            new CountryViewModel("Saint Pierre and Miquelon", "PM"),
            new CountryViewModel("Saint Vincent and the Grenadines", "VC"),
            new CountryViewModel("Samoa", "WS"),
            new CountryViewModel("San Marino", "SM"),
            new CountryViewModel("Sao Tome and Principe", "ST"),
            new CountryViewModel("Saudi Arabia", "SA"),
            new CountryViewModel("Senegal", "SN"),
            new CountryViewModel("Serbia", "RS"),
            new CountryViewModel("Seychelles", "SC"),
            new CountryViewModel("Sierra Leone", "SL"),
            new CountryViewModel("Singapore", "SG"),
            new CountryViewModel("Sint Maarten (Dutch part)", "SX"),
            new CountryViewModel("Slovakia", "SK"),
            new CountryViewModel("Slovenia", "SI"),
            new CountryViewModel("Solomon Islands", "SB"),
            new CountryViewModel("Somalia", "SO"),
            new CountryViewModel("South Africa", "ZA"),
            new CountryViewModel("South Georgia and the South Sandwich Islands", "GS"),
            new CountryViewModel("South Sudan", "SS"),
            new CountryViewModel("Spain", "ES"),
            new CountryViewModel("Sri Lanka", "LK"),
            new CountryViewModel("Sudan", "SD"),
            new CountryViewModel("Suriname", "SR"),
            new CountryViewModel("Svalbard and Jan Mayen", "SJ"),
            new CountryViewModel("Swaziland", "SZ"),
            new CountryViewModel("Sweden", "SE"),
            new CountryViewModel("Switzerland", "CH"),
            new CountryViewModel("Syrian Arab Republic", "SY"),
            new CountryViewModel("Taiwan, Province of China[a]", "TW"),
            new CountryViewModel("Tajikistan", "TJ"),
            new CountryViewModel("Tanzania, United Republic of", "TZ"),
            new CountryViewModel("Thailand", "TH"),
            new CountryViewModel("Timor-Leste", "TL"),
            new CountryViewModel("Togo", "TG"),
            new CountryViewModel("Tokelau", "TK"),
            new CountryViewModel("Tonga", "TO"),
            new CountryViewModel("Trinidad and Tobago", "TT"),
            new CountryViewModel("Tunisia", "TN"),
            new CountryViewModel("Turkey", "TR"),
            new CountryViewModel("Turkmenistan", "TM"),
            new CountryViewModel("Turks and Caicos Islands", "TC"),
            new CountryViewModel("Tuvalu", "TV"),
            new CountryViewModel("Uganda", "UG"),
            new CountryViewModel("Ukraine", "UA"),
            new CountryViewModel("United Arab Emirates", "AE"),
            new CountryViewModel("United Kingdom of Great Britain and Northern Ireland", "GB"),
            new CountryViewModel("United States of America", "US"),
            new CountryViewModel("United States Minor Outlying Islands", "UM"),
            new CountryViewModel("Uruguay", "UY"),
            new CountryViewModel("Uzbekistan", "UZ"),
            new CountryViewModel("Vanuatu", "VU"),
            new CountryViewModel("Venezuela (Bolivarian Republic of)", "VE"),
            new CountryViewModel("Viet Nam", "VN"),
            new CountryViewModel("Virgin Islands (British)", "VG"),
            new CountryViewModel("Virgin Islands (U.S.)", "VI"),
            new CountryViewModel("Wallis and Futuna", "WF"),
            new CountryViewModel("Western Sahara", "EH"),
            new CountryViewModel("Yemen", "YE"),
            new CountryViewModel("Zambia", "ZM"),
            new CountryViewModel("Zimbabwe", "ZW"),
        }.AsReadOnly();
    }
}
